package org.epistasis.gui;

import java.awt.Font;

import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.JTableHeader;

import org.epistasis.mdr.ExpertKnowledge;
import org.epistasis.mdr.newengine.Dataset;

public class DatafilePanel extends JScrollPane {
    /**
	 * 
	 */
    private static final long serialVersionUID = 1L;
    /** Table to hold data values */
    JTable tblDataFile = new JTable();

    // /** Data representation of the table */
    // private final DefaultTableModel dtmDataFile = new ReadOnlyTableModel();
    /** Cell renderer used to right-justify columns */
    // private final DefaultTableCellRenderer dcrDataFile = new
    // DefaultTableCellRenderer();
    public DatafilePanel() {

	jbInit();
    }

    private void jbInit() {
	tblDataFile = new JTable();
	tblDataFile.setFillsViewportHeight(true);
	tblDataFile.setRowSelectionAllowed(false);
	setViewportView(tblDataFile);
	// do not resize columns -- use scroll bar instead
	tblDataFile.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
	final JTableHeader jTableHeader = tblDataFile.getTableHeader();
	jTableHeader.setReorderingAllowed(false);
	((DefaultTableCellRenderer) jTableHeader.getDefaultRenderer())
		.setHorizontalAlignment(SwingConstants.CENTER);
	((DefaultTableCellRenderer) tblDataFile
		.getDefaultRenderer(String.class))
		.setHorizontalAlignment(SwingConstants.CENTER);
    }

    /**
     * Display a data set.
     * 
     * @param data
     *            Dataset to display
     */
    public void readDatafile(final Dataset data) {
	// need to replace columnModel entirely to eliminate very slow
	// modification of existing columnModel with many columns
	tblDataFile.setColumnModel(new DefaultTableColumnModel());
	tblDataFile.setModel(data.new DatasetTableModel());
    }

    public void readDatafile(final ExpertKnowledge expertKnowledge) {
	tblDataFile.setModel(expertKnowledge.getTableModel());
    }

    @Override
    public void setFont(final Font font) {
	super.setFont(font);
	if (tblDataFile == null) {
	    return;
	}
	tblDataFile.setFont(font);
	tblDataFile.getTableHeader().setFont(font);
    }

}
