package org.epistasis.gui;

import javax.swing.SwingUtilities;
import javax.swing.text.JTextComponent;

import org.epistasis.Utility;

public class TextComponentUpdaterThread extends Thread {
    private final JTextComponent component;
    private final Object textgen;
    private final Runnable target;

    public TextComponentUpdaterThread(final JTextComponent component,
	    final Object textgen) {
	this(component, textgen, null);
    }

    public TextComponentUpdaterThread(final JTextComponent component,
	    final Object textgen, final Runnable target) {
	super("TextComponentUpdaterThread-"
		+ textgen.getClass().getSimpleName());
	this.component = component;
	this.textgen = textgen;
	this.target = target;
    }

    @Override
    public void run() {
	SwingUtilities.invokeLater(new TextSetter());
    }

    private class TextSetter implements Runnable {
	public TextSetter() {
	}

	@Override
	public void run() {
	    try {
		component.setText(textgen.toString());
		component.select(0, 0);
		if (target != null) {
		    target.run();
		}
	    } catch (final Exception ex) {
		System.err.println(Thread.currentThread().getName()
			+ " caught excption: " + ex + "\nALL STACK TRACES:\n"
			+ Utility.getAllStackTraces());
	    }
	}
    }
}
